'use strict';

const stylelint = {
  extends: [
    "stylelint-config-standard",
    "stylelint-config-css-modules",
    "stylelint-config-rational-order",
    "stylelint-config-prettier",
    "stylelint-no-unsupported-browser-features"
  ],
  plugins: ["stylelint-order", "stylelint-declaration-block-no-ignored-properties"],
  rules: {
    "no-descending-specificity": null,
    "function-calc-no-invalid": null,
    "function-url-quotes": "always",
    "font-family-no-missing-generic-family-keyword": null,
    "plugin/declaration-block-no-ignored-properties": true,
    "unit-no-unknown": [true, {ignoreUnits: ["rpx"]}]
  },
  ignoreFiles: ["**/*.js", "**/*.jsx", "**/*.tsx", "**/*.ts"]
};

module.exports = stylelint;
